#include <iostream>
#include <vector>
#include <algorithm>

//1 2 3 4 5 6 7 8 9
//          6 7 8 9
//              8 9

int broj_parova_v1(const std::vector<int> &a, int s) // O(n ^ 2)
{
    int broj = 0, n = a.size(), x;

    for (int i = 0; i < n; i++) {
        x = a[i];
        for (int j = i + 1; j < n; j++) {
            if (a[j] == s - x) {
                broj++;
            }
        }
    }

    return broj;
}

int broj_parova_v2(std::vector<int> &a, int s) // O(n ^ 2)
{
    std::sort(a.begin(), a.end());

    int broj = 0, n = a.size(), x;

    for (int i = 0; i < n; i++) {
        x = a[i];
        if (std::binary_search(a.begin() + i + 1, a.end(), s - x)) {
            broj++;
        }
    }

    return broj;
}

int main ()
{
    int n, s;

    std::cin >> s >> n;

    std::vector<int> a(n);

    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }

    std::cout << broj_parova_v1(a, s) << "\n";

    std::cout << broj_parova_v2(a, s) << "\n";

    return 0;
}