// Кошаркашки тим је играо пуно утакмица у сезони. У свакој утакмици остварио је или победу или пораз.
// Напиши програм који одређује дужину најдуже серије победа у узастопним мечевима током сезоне.

// Улаз: Са стандардног улаза се уноси природан број N (5 ≤ N ≤ 50000), а затим и N бројева -1 (што
// означава пораз) или 1 (што означава победу).

// Излаз: На стандардни излаз исписати један природан број који представља тражену дужину најдуже серије
// узастопних победа

#include <iostream>
#include <vector>
#include <climits>

int pobede_v1(const std::vector<int> &a) // O(n ^ 3)
{
    int max = 0 /*INT_MIN*/, n = a.size(), brojac;

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            brojac = 0;
            for (int k = i; k <= j; k++) {
                if (a[k] == -1) {
                    if (brojac > max) {
                        max = brojac;
                    }
                    break;
                }
                // sigurno je pobeda
                else {
                    brojac++;
                }
            }
        }
    }

    if (brojac > max) {
        max = brojac;
    }


    return max;
}

int pobede_v2(const std::vector<int> &a) // O(n)
{
    int max = 0, trenutni = 0, n = a.size();

    int i = 0;

    while (i < n) {
        if (a[i] == 1) {
            trenutni++;
        }
        else {
            if (trenutni > max) {
                max = trenutni;
            }
            trenutni = 0;
        }
        i++;
    }

    if (trenutni > max) {
        max = trenutni;
    }

    return max;
}


int main ()
{
    int n;

    std::cin >> n;

    std::vector<int> a(n);

    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }

    std::cout << pobede_v1(a) << "\n";

    std::cout << pobede_v2(a) << "\n";

    return 0;
}